engine,love.run=(function ()
  local get=function (folder)
    local cache={}
    setmetatable(cache,{__mode='v'})
    return function(name)
      local x=cache[name]
      if not x then
        x=love.filesystem.load( folder .. '/' .. name .. '.lua' )()
        cache[name]=x
      end
      return x
    end
  end
  local updater={}
  setmetatable(updater,{__mode='k'})
  return {
    getModul=get("modul"),
    getScene=get("scene"),
    setUpdater=(function (key,func)
      updater[key]=func
    end)
  },function ()
    love.timer.step()
    while true do
      if love.event then
        love.event.pump()
        for name,a,b,c,d,e,f in love.event.poll() do
          if name == "quit" then
            return a
          elseif name=="keypressed" then     
            scene.keypressed(a,c)
          elseif name=="textinput" then     
            if scene.textinput then
              scene.textinput(a)
            end
          else
            --print(name,a,b,c,d,e,f)
          end        
        end
      end
      love.timer.step()
      local dt=love.timer.getDelta()
      for k,f in pairs(updater) do
        f(dt)
      end
      scene.draw()
      love.graphics.present()
      love.timer.sleep(0.001)
    end
  end
end)()
