return (function ()
  local make=function ()
    local pal={}
    for p=0,31 do
      pal[p]={{15,0,15},{0,0,15},{15,15,15}}
      pal[p][0]={0,0,15}
      pal[p][0][0]=0
      pal[p][1][0]=0
      pal[p][2][0]=15
      pal[p][3][0]=15
    end
    local data=love.image.newImageData(32,4)
    local image=love.graphics.newImage(data)
    image:setWrap("repeat","repeat")
    image:setFilter("nearest","nearest")
    return {getColor=function(p,c)
      return pal[p][c]
    end, getImage=function()
      local ptr=ffi.cast('unsigned char*',data:getPointer())
      for c=0,3 do 
        for p=0,31 do
          local f=pal[p][c]
          for x=0,3 do
            ptr[0]=f[x]*17
            ptr=ptr+1
          end
        end
      end
      image:refresh()
      return image
    end, getBytes=function()
      local data=''
      for p=0,31 do
        for c=0,3 do
          data=data..string.char(pal[p][c][0]+pal[p][c][1]*16,pal[p][c][2]+pal[p][c][3]*16)
        end
      end
      return data
    end, setBytes=function(data)
      local pos=1
      for p=0,31 do
        for c=0,3 do
          local v=data:byte(pos)
          local e=pal[p][c]
          e[0]=bit.band(v,15)
          e[1]=bit.rshift(v,4)
          pos=pos+1
          local v=data:byte(pos)
          e[2]=bit.band(v,15)
          e[3]=bit.rshift(v,4)
          pos=pos+1
        end
      end
      return pos-1
    end}
  end
  return {new=make}
end)()
