return (function ()
  local tilesets={default=engine.getModul('tileset').new()}
  local palettes={default=engine.getModul('palette').new()}
  local writeString=function (str)
    return string.char(#str)..str
  end
  local readString=function (pos,data)
    local c=data:byte(pos)
    return pos+1+c,data:sub(pos+1,pos+c)
  end
  return {load=function (path)
    local data=love.filesystem.read(path)
    if data:byte(1)~=0 then return end
    local pos=2
    local k
    palettes={}
    pos,k=readString(pos,data)
    while #k>0 do
      palettes[k]=engine.getModul('palette').new()
      pos=pos+palettes[k].setBytes(data:sub(pos))
      pos,k=readString(pos,data)
    end
    tilesets={}
    pos,k=readString(pos,data)
    while #k>0 do
      tilesets[k]=engine.getModul('tileset').new()
      pos=pos+tilesets[k].setBytes(data:sub(pos))
      pos,k=readString(pos,data)
    end
  end,save=function (path)
    data=string.char(0)
    for k,v in pairs(palettes) do
      data=data..writeString(k)
      data=data..v.getBytes()
    end
    data=data..writeString('')
    for k,v in pairs(tilesets) do
      data=data..writeString(k)
      data=data..v.getBytes()
    end
    data=data..writeString('')    
    love.filesystem.write(path,data)
  end,getTileset=function(name)  
    return tilesets[name]
  end,getPalette=function(name)  
    return palettes[name]
  end}
end)()
