return (function ()
  local make=function ()
    local tiles={}
    for i=0,255 do
      tiles[i]={}
      for y=0,15 do
        tiles[i][y]={}
        for x=0,15 do
          tiles[i][y][x]=0
        end
      end
    end
    local data=love.image.newImageData(256,256)
    local image=love.graphics.newImage(data)
    image:setWrap("clamp","clamp")
    image:setFilter("nearest","nearest")    
    return {getTile=function(i)
      return tiles[i]      
    end, getImage=function()
      local ptr=ffi.cast('unsigned char*',data:getPointer())
      for ty=0,15 do
        for y=0,15 do
          for tx=0,15 do 
            for x=0,15 do
              ptr[0]=tiles[tx+ty*16][y][x]*64
              ptr=ptr+4
            end
          end
        end
      end
      image:refresh()
      return image                
    end, copyTile=function(o,n)
      o,n=tiles[o],tiles[n]
      for y=0,15 do
        for x=0,15 do
          n[y][x]=o[y][x]
        end
      end
    end, getBytes=function()
      local data=""
      for i=0,255 do
        for y=0,15 do
          local tile=tiles[i][y]
          for x=0,15,4 do
            data=data..string.char(tile[x]+tile[x+1]*4+tile[x+2]*16+tile[x+3]*64)
          end
        end
      end
      return data
    end, setBytes=function(data)
      local pos=1
      for i=0,255 do
        for y=0,15 do
          local tile=tiles[i][y]
          for x=0,15,4 do
            local c=data:byte(pos)
            tile[x]=bit.band(c,3)
            tile[x+1]=bit.band(bit.rshift(c,2),3)
            tile[x+2]=bit.band(bit.rshift(c,4),3)
            tile[x+3]=bit.rshift(c,6)
            pos=pos+1
          end
        end
      end
      return pos-1
    end}
  end
  return {new=make}
end)()
