return (function (items,back)
  local pos=0
  local font=love.graphics.newFont(24)
  return {draw=function ()
    local width,height=love.graphics.getDimensions()
    local N=math.floor(height/64)-1
    love.graphics.clear()
    love.graphics.setFont(font)
    for n=-N,N do
      local item=items[((pos+n)%#items)+1]
      if item[2] then
        love.graphics.setColor(255,255,255,255*(1-math.abs(n)/(N+1)))
      else
        love.graphics.setColor(0,255,0,255*(1-math.abs(n)/(N+1)))
      end
      love.graphics.print(item[1],(width-font:getWidth(item[1]))/2,(height-24)/2+n*32)
    end
    local h=font:getWidth(items[(pos%#items)+1][1])
    love.graphics.setColor(255,0,0,255)
    love.graphics.rectangle("fill",0,(height-4)/2,(width-h-4)/2,4)
    love.graphics.rectangle("fill",(width+h+4)/2,(height-4)/2,(width-h-4)/2,4)
  end, keypressed=function (key,isRepeat)
    if key=='left' then
      back()
    elseif key=='right' then
      items[pos+1][3]()
    elseif key=='up' then
      pos=(pos-1)%#items
    elseif key=='down' then
      pos=(pos+1)%#items
    end  
  end}
end)

