return (function (back)
  local data=love.image.newImageData(256,256)
  local image=love.graphics.newImage(data)
  local ptr=ffi.cast('unsigned char*',data:getPointer())
  local c=255
  for ys=0,255,16 do
    for y=0,15 do
      for xs=0,255,16 do
        for x=0,15 do
          ptr[0]=c
          ptr[1]=255-c
          ptr[2]=255
          ptr[3]=255
          ptr=ptr+4
        end
        c=255-c
      end
    end
    c=255-c
  end  
  image:refresh()
  local mesh = love.graphics.newMesh({{"VertexPosition", "float", 2},{"VertexTexCoord3", "float", 3}},
       {{0,600,0,0,1},{360,0,0,.1,.1},{800,600,1,0,1},{440,0,.1,.1,.1}}, "strip")
  mesh:setTexture(image)
  local effect=love.graphics.newShader([[
    attribute vec3 VertexTexCoord3;
    varying vec3 v_texcoord;
 
    vec4 position(mat4 transform_projection, vec4 vertex_position )
    {
      v_texcoord = VertexTexCoord3;
      return transform_projection * vertex_position;
    }  
  ]],[[
    varying vec3 v_texcoord;
    
    vec4 effect(vec4 color,Image texture,vec2 texture_coords,vec2 pixel_coords)
    {
      return Texel(texture, vec2(v_texcoord.x/v_texcoord.z,v_texcoord.y/v_texcoord.z));
    }
  ]])
  return {draw=function ()
    local width,height=love.graphics.getDimensions()
    local width2,height2=width/2,height/2
    love.graphics.clear()
    love.graphics.setColor(255,255,255,255)
    love.graphics.setShader(effect)    
    love.graphics.draw(mesh)
    love.graphics.setShader()    
  end, keypressed=function (key,isRepeat)
    if key=='escape' then
      back()
    end  
  end}
end)

