return (function (pal,tile,back)
  local background=engine.getModul('barBackground')
  local pos={x=0,y=0}
  local colorpos={p=0,c=0}
  local colorpart=0
  return {draw=function ()
    background()
    local width,height=love.graphics.getDimensions()
    local width2,height2=width/2,height/2
    for y=0,15 do
      for x=0,15 do
        love.graphics.setColor(toScreenColor(pal.getColor(colorpos.p,tile[y][x])))
        love.graphics.rectangle("fill",width2+(x-8)*24,height2+(y-8)*24,24,24)
      end
    end
    for p=0,31 do
      for c=0,3 do
        love.graphics.setColor(toScreenColor(pal.getColor(p,c)))
        love.graphics.rectangle("fill",width2+(p-16)*24,c*24,24,24)      
      end
    end    
    for p=0,3 do
      for c=0,15 do
        local color=toScreenColor(pal.getColor(colorpos.p,colorpos.c))
        color[4]=255
        color[p+1]=c*17
        love.graphics.setColor(color)
        love.graphics.rectangle("fill",width+(c-16)*24,height+(p-4)*24,24,24)      
      end
    end
    love.graphics.setColor(0,0,0,255)
    love.graphics.rectangle("fill",width2+(pos.x-8)*24+5,height2-8*24,4,384)
    love.graphics.rectangle("fill",width2+(pos.x-8)*24+15,height2-8*24,4,384)
    love.graphics.rectangle("fill",width2-8*24,height2+(pos.y-8)*24+5,384,4)
    love.graphics.rectangle("fill",width2-8*24,height2+(pos.y-8)*24+15,384,4)
    love.graphics.rectangle("fill",width2+(colorpos.p-16)*24+5,0,4,96)
    love.graphics.rectangle("fill",width2+(colorpos.p-16)*24+15,0,4,96)
    love.graphics.rectangle("fill",width2-16*24,colorpos.c*24+5,768,4)
    love.graphics.rectangle("fill",width2-16*24,colorpos.c*24+15,768,4)
    for p=0,3 do
      local c=pal.getColor(colorpos.p,colorpos.c)[p]
      love.graphics.rectangle("fill",width+(c-16)*24+5,height+(p-4)*24,4,24)
      love.graphics.rectangle("fill",width+(c-16)*24+15,height+(p-4)*24,4,24)      
    end
    love.graphics.rectangle("fill",width-16*24,height+(colorpart-4)*24+5,384,4)
    love.graphics.rectangle("fill",width-16*24,height+(colorpart-4)*24+15,384,4)
    love.graphics.setColor(255,255,255,255)
    love.graphics.rectangle("fill",width2+(pos.x-8)*24+6,height2-8*24,2,384)
    love.graphics.rectangle("fill",width2+(pos.x-8)*24+16,height2-8*24,2,384)
    love.graphics.rectangle("fill",width2-8*24,height2+(pos.y-8)*24+6,384,2)
    love.graphics.rectangle("fill",width2-8*24,height2+(pos.y-8)*24+16,384,2)        
    love.graphics.rectangle("fill",width2+(colorpos.p-16)*24+6,0,2,96)
    love.graphics.rectangle("fill",width2+(colorpos.p-16)*24+16,0,2,96)
    love.graphics.rectangle("fill",width2-16*24,colorpos.c*24+6,768,2)
    love.graphics.rectangle("fill",width2-16*24,colorpos.c*24+16,768,2)
    for p=0,3 do
      local c=pal.getColor(colorpos.p,colorpos.c)[p]
      love.graphics.rectangle("fill",width+(c-16)*24+6,height+(p-4)*24,2,24)
      love.graphics.rectangle("fill",width+(c-16)*24+16,height+(p-4)*24,2,24)      
    end    
    love.graphics.rectangle("fill",width-16*24,height+(colorpart-4)*24+6,384,2)
    love.graphics.rectangle("fill",width-16*24,height+(colorpart-4)*24+16,384,2)
  end, keypressed=function (key,isRepeat)
    if love.keyboard.isDown('rshift') then
      if key=='left' then
        colorpos.p=(colorpos.p-1)%32
      elseif key=='right' then
        colorpos.p=(colorpos.p+1)%32
      elseif key=='up' then
        colorpos.c=(colorpos.c-1)%4
      elseif key=='down' then
        colorpos.c=(colorpos.c+1)%4
      end
    elseif love.keyboard.isDown('lshift') then
      local color=pal.getColor(colorpos.p,colorpos.c)
      if key=='left' then
        color[colorpart]=(color[colorpart]-1)%16
      elseif key=='right' then
        color[colorpart]=(color[colorpart]+1)%16
      elseif key=='up' then
        colorpart=(colorpart-1)%4
      elseif key=='down' then
        colorpart=(colorpart+1)%4
      end      
    else
      if key=='left' then
        pos.x=(pos.x-1)%16
      elseif key=='right' then
        pos.x=(pos.x+1)%16
      elseif key=='up' then
        pos.y=(pos.y-1)%16
      elseif key=='down' then
        pos.y=(pos.y+1)%16
      elseif key=='tab' then
        back()
      end
      if love.keyboard.isDown(' ') then
        tile[pos.y][pos.x]=colorpos.c
      end
    end
  end} 
end)
