return (function (tiles,palette,back)
  local background=engine.getModul('barBackground')
  local leftmap=engine.getModul('tilemap').new(8,32)
  local rightmap=engine.getModul('tilemap').new(8,32)
  local palimage=palette.getImage()
  local image=tiles.getImage()
  local curpalette=0
  local pos={x=0,y=0}
  local leftpos={x=0,y=0}
  local me
  local effect=love.graphics.newShader [[
    extern vec4 palette[4];
    vec4 effect(vec4 color,Image texture,vec2 texture_coords,vec2 pixel_coords)
    {
      return palette[int(Texel(texture,texture_coords).r*4)];
    }
  ]]
  local updateColor=function ()
    effect:send("palette"
      ,toScreenColor(palette.getColor(curpalette,0))
      ,toScreenColor(palette.getColor(curpalette,1))
      ,toScreenColor(palette.getColor(curpalette,2))
      ,toScreenColor(palette.getColor(curpalette,3))
      )
  end
  local updateMap=function (map,index)
    for y=0,31 do
      map.setCell(0,y,index,y,false,false,false)
      map.setCell(1,y,index,y,true,false,false)
      map.setCell(2,y,index,y,false,true,false)
      map.setCell(3,y,index,y,true,true,false)
      map.setCell(4,y,index,y,false,false,true)
      map.setCell(5,y,index,y,true,false,true)
      map.setCell(6,y,index,y,false,true,true)
      map.setCell(7,y,index,y,true,true,true)
    end
    map.flip()
  end  
  updateColor()
  updateMap(leftmap,0)
  updateMap(rightmap,0)
  me={draw=function ()
    background()
    local width,height=love.graphics.getDimensions()
    local width2,height2=width/2,height/2
    for p=0,31 do
      love.graphics.setColor(toScreenColor(palette.getColor(p,0)))
      love.graphics.rectangle("fill",width2+(p-16)*24,0,12,12)
      love.graphics.setColor(toScreenColor(palette.getColor(p,1)))
      love.graphics.rectangle("fill",width2+(p-16)*24+12,0,12,12)
      love.graphics.setColor(toScreenColor(palette.getColor(p,2)))
      love.graphics.rectangle("fill",width2+(p-16)*24,12,12,12)
      love.graphics.setColor(toScreenColor(palette.getColor(p,3)))
      love.graphics.rectangle("fill",width2+(p-16)*24+12,12,12,12)
    end
    love.graphics.setShader(effect)
    love.graphics.draw(image,width2-256,height2-256,0,2,2)
    love.graphics.setShader()
    leftmap.draw(image,palimage,0,height2-256,128,512,{0,0},{8,32})
    rightmap.draw(image,palimage,width-128,height2-256,128,512,{0,0},{8,32})
    love.graphics.setColor(0,0,0,255)
    love.graphics.rectangle("fill",width2+(pos.x-8)*32+9,height2-8*32,2,512)
    love.graphics.rectangle("fill",width2+(pos.x-8)*32+19,height2-8*32,2,512)
    love.graphics.rectangle("fill",width2-8*32,height2+(pos.y-8)*32+9,512,4)
    love.graphics.rectangle("fill",width2-8*32,height2+(pos.y-8)*32+19,512,4)    
    love.graphics.rectangle("fill",width2+(curpalette-16)*24+5,0,4,24)
    love.graphics.rectangle("fill",width2+(curpalette-16)*24+15,0,4,24)
    love.graphics.setColor(255,255,255,255)
    love.graphics.rectangle("fill",width2+(pos.x-8)*32+10,height2-8*32,2,512)
    love.graphics.rectangle("fill",width2+(pos.x-8)*32+20,height2-8*32,2,512)
    love.graphics.rectangle("fill",width2-8*32,height2+(pos.y-8)*32+10,512,2)
    love.graphics.rectangle("fill",width2-8*32,height2+(pos.y-8)*32+20,512,2)        
    love.graphics.rectangle("fill",width2+(curpalette-16)*24+6,0,2,24)
    love.graphics.rectangle("fill",width2+(curpalette-16)*24+16,0,2,24)
  end, keypressed=function (key,isRepeat)
    if love.keyboard.isDown('rshift') then
      if key=='left' then
        curpalette=(curpalette-1)%32
        updateColor()
      elseif key=='right' then
        curpalette=(curpalette+1)%32
        updateColor()
      elseif key==' ' then
        tiles.copyTile(leftpos.x+leftpos.y*16,pos.x+pos.y*16)
        image=tiles.getImage()        
      elseif key=='tab' then
        back()
      end
    else
      if key=='left' then
        pos.x=(pos.x-1)%16
        updateMap(rightmap,pos.x+pos.y*16)
      elseif key=='right' then
        pos.x=(pos.x+1)%16
        updateMap(rightmap,pos.x+pos.y*16)
      elseif key=='up' then
        pos.y=(pos.y-1)%16
        updateMap(rightmap,pos.x+pos.y*16)
      elseif key=='down' then
        pos.y=(pos.y+1)%16
        updateMap(rightmap,pos.x+pos.y*16)
      elseif key=='tab' then
        scene=engine.getScene('tileeditor')(palette,tiles.getTile(pos.x+pos.y*16),function ()
          image=tiles.getImage()
          palimage=palette.getImage()
          updateColor()
          scene=me
        end)
      elseif key==' ' then
        leftpos={x=pos.x,y=pos.y}
        updateMap(leftmap,pos.x+pos.y*16)
      end
    end
  end}
  return me
end)
